![GitHub Action](https://img.shields.io/github/actions/workflow/status/waku-org/js-waku/ci.yml?branch=master)
![Code Climate](https://img.shields.io/codeclimate/maintainability/waku-org/js-waku)
[![Discord chat](https://img.shields.io/discord/1110799176264056863.svg?logo=discord&colorB=7289DA)](https://discord.waku.org)

# js-waku

A TypeScript implementation of the [Waku v2 protocol](https://rfc.vac.dev/spec/10/).

## Documentation

- [Quick start](https://docs.waku.org/guides/js-waku/#getting-started)
- [Full documentation](https://docs.waku.org/guides/js-waku)
- [API documentation (`master` branch)](https://js.waku.org/)
- [Waku](https://waku.org/)
- [Vac](https://vac.dev/)

API Documentation can also be generated locally:

```shell
git clone https://github.com/waku-org/js-waku.git
cd js-waku
npm install
npm run doc
```

## Bugs, Questions & Features

If you encounter any bug or would like to propose new features, feel free to [open an issue](https://github.com/waku-org/js-waku/issues/new/).

For general discussion, get help or latest news, join us on [Vac Discord](https://discord.gg/Nrac59MfSX) or the [Waku Telegram Group](https://t.me/waku_org).

## Roadmap

You can track progress on the [project board](https://github.com/orgs/waku-org/projects/2/views/1).

## Contributing

See [CONTRIBUTING.md](https://github.com/waku-org/js-waku/blob/master/CONTRIBUTING.md).

## License

Licensed and distributed under either of

- MIT license: [LICENSE-MIT](https://github.com/waku-org/js-waku/blob/master/LICENSE-MIT) or http://opensource.org/licenses/MIT

or

- Apache License, Version 2.0, ([LICENSE-APACHE-v2](https://github.com/waku-org/js-waku/blob/master/LICENSE-APACHE-v2) or http://www.apache.org/licenses/LICENSE-2.0)

at your option. These files may not be copied, modified, or distributed except according to those terms.
