[![NPM](https://nodei.co/npm/@waku/core.png)](https://npmjs.org/package/@waku/core)

[![Discord chat](https://img.shields.io/discord/864066763682218004.svg?logo=discord&colorB=7289DA)](https://discord.gg/Nrac59MfSX)

# @waku/core

Core components of js-waku, a TypeScript implementation of the [Waku v2 protocol](https://rfc.vac.dev/spec/10/).

## Documentation

- [Quick start](https://docs.wakuconnect.dev/docs/quick_start/)
- [Full documentation](https://docs.wakuconnect.dev/)
- [API documentation (`master` branch)](https://js.waku.org/)
- [Waku Connect](https://wakuconnect.dev/)
- [Waku](https://wakunetwork.com/)
- [Vac](https://vac.dev/)

API Documentation can also be generated locally:

```shell
git clone https://github.com/waku-org/js-waku.git
cd js-waku
npm install
npm run doc
```

## Changelog

Release changelog can be found in [CHANGELOG.md](https://github.com/waku-org/js-waku/blob/master/packages/core/CHANGELOG.md).

## Bugs, Questions & Features

If you encounter any bug or would like to propose new features, feel free to [open an issue](https://github.com/waku-org/js-waku/issues/new/).

For general discussion, get help or latest news, join **#js-waku** on [Vac Discord](https://discord.gg/Nrac59MfSX) or the [Waku Telegram Group](https://t.me/waku_org).

## Roadmap

You can track progress on the [project board](https://github.com/orgs/waku-org/projects/2/views/1).

## Contributing

See [CONTRIBUTING.md](https://github.com/waku-org/js-waku/blob/master/CONTRIBUTING.md).

## License

Licensed and distributed under either of

- MIT license: [LICENSE-MIT](https://github.com/waku-org/js-waku/blob/master/LICENSE-MIT) or http://opensource.org/licenses/MIT

or

- Apache License, Version 2.0, ([LICENSE-APACHE-v2](https://github.com/waku-org/js-waku/blob/master/LICENSE-APACHE-v2) or http://www.apache.org/licenses/LICENSE-2.0)

at your option. These files may not be copied, modified, or distributed except according to those terms.
