# Changelog

All notable changes to this project will be documented in this file.

The file is maintained by [Release Please](https://github.com/googleapis/release-please) based on [Conventional Commits](https://www.conventionalcommits.org) specification,
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

### Dependencies

* The following workspace dependencies were updated
  * devDependencies
    * @waku/interfaces bumped from 0.0.8 to 0.0.9

### Dependencies

* The following workspace dependencies were updated
  * dependencies
    * @waku/utils bumped from 0.0.2 to 0.0.3
  * devDependencies
    * @waku/interfaces bumped from 0.0.9 to 0.0.10

### Dependencies

* The following workspace dependencies were updated
  * dependencies
    * @waku/utils bumped from 0.0.3 to 0.0.4
  * devDependencies
    * @waku/interfaces bumped from 0.0.10 to 0.0.11

### Dependencies

* The following workspace dependencies were updated
  * dependencies
    * @waku/utils bumped from 0.0.4 to 0.0.5
  * devDependencies
    * @waku/interfaces bumped from 0.0.11 to 0.0.12

### Dependencies

* The following workspace dependencies were updated
  * dependencies
    * @waku/utils bumped from 0.0.6 to 0.0.7
  * devDependencies
    * @waku/interfaces bumped from 0.0.13 to 0.0.14

### Dependencies

* The following workspace dependencies were updated
  * dependencies
    * @waku/utils bumped from 0.0.7 to 0.0.8
  * devDependencies
    * @waku/interfaces bumped from 0.0.14 to 0.0.15

### Dependencies

* The following workspace dependencies were updated
  * dependencies
    * @waku/utils bumped from 0.0.9 to 0.0.10
  * devDependencies
    * @waku/interfaces bumped from 0.0.16 to 0.0.17

### Dependencies

* The following workspace dependencies were updated
  * dependencies
    * @waku/utils bumped from 0.0.13 to 0.0.14
  * devDependencies
    * @waku/interfaces bumped from 0.0.20 to 0.0.21

## [0.0.21](https://github.com/waku-org/js-waku/compare/enr-v0.0.20...enr-v0.0.21) (2024-03-04)


### ⚠ BREAKING CHANGES

* protocols filter peers as per configured shard ([#1756](https://github.com/waku-org/js-waku/issues/1756))

### Features

* Protocols filter peers as per configured shard ([#1756](https://github.com/waku-org/js-waku/issues/1756)) ([477c2a5](https://github.com/waku-org/js-waku/commit/477c2a5918f2f75cd2c14bc6ed75e1687c5a09b4))


### Bug Fixes

* **tests:** Append `p2p` with the multiaddrs from ENR ([#1817](https://github.com/waku-org/js-waku/issues/1817)) ([f8e02ab](https://github.com/waku-org/js-waku/commit/f8e02ab19eefd616926e17900602dcef28b068ff))


### Dependencies

* The following workspace dependencies were updated
  * dependencies
    * @waku/utils bumped from 0.0.14 to 0.0.15
  * devDependencies
    * @waku/interfaces bumped from 0.0.21 to 0.0.22

## [0.0.19](https://github.com/waku-org/js-waku/compare/enr-v0.0.18...enr-v0.0.19) (2023-11-01)


### Features

* Logger with log levels ([#1672](https://github.com/waku-org/js-waku/issues/1672)) ([0f7d63e](https://github.com/waku-org/js-waku/commit/0f7d63ef93716223dc8fea7e8cb09e12e267b386))


### Dependencies

* The following workspace dependencies were updated
  * dependencies
    * @waku/utils bumped from 0.0.12 to 0.0.13
  * devDependencies
    * @waku/interfaces bumped from 0.0.19 to 0.0.20

## [0.0.18](https://github.com/waku-org/js-waku/compare/enr-v0.0.17...enr-v0.0.18) (2023-10-16)


### Features

* Add Firefox and Webkit to karma  ([#1598](https://github.com/waku-org/js-waku/issues/1598)) ([d9e4bcb](https://github.com/waku-org/js-waku/commit/d9e4bcbe3f7bcc092f20621bd362d76426701dab))
* **static-sharding:** Filter peer connections per shards ([#1626](https://github.com/waku-org/js-waku/issues/1626)) ([124a29e](https://github.com/waku-org/js-waku/commit/124a29ebba59c05fbbf199d969e6ba3f9e57d45b))


### Dependencies

* The following workspace dependencies were updated
  * dependencies
    * @waku/utils bumped from 0.0.11 to 0.0.12
  * devDependencies
    * @waku/interfaces bumped from 0.0.18 to 0.0.19

## [0.0.17](https://github.com/waku-org/js-waku/compare/enr-v0.0.16...enr-v0.0.17) (2023-09-11)


### ⚠ BREAKING CHANGES

* upgrade to libp2p@0.45 ([#1400](https://github.com/waku-org/js-waku/issues/1400))
* @waku/relay ([#1316](https://github.com/waku-org/js-waku/issues/1316))

### Features

* @waku/relay ([#1316](https://github.com/waku-org/js-waku/issues/1316)) ([50c2c25](https://github.com/waku-org/js-waku/commit/50c2c2540f3c5ff78d93f3fea646da0eee246e17))
* Upgrade to libp2p@0.45 ([#1400](https://github.com/waku-org/js-waku/issues/1400)) ([420e6c6](https://github.com/waku-org/js-waku/commit/420e6c698dd8f44d40d34e47d876da5d2e1ce85e))


### Dependencies

* The following workspace dependencies were updated
  * dependencies
    * @waku/utils bumped from 0.0.10 to 0.0.11
  * devDependencies
    * @waku/interfaces bumped from 0.0.17 to 0.0.18

## [0.0.15](https://github.com/waku-org/js-waku/compare/enr-v0.0.14...enr-v0.0.15) (2023-07-26)


### ⚠ BREAKING CHANGES

* upgrade to libp2p@0.45 ([#1400](https://github.com/waku-org/js-waku/issues/1400))

### Features

* Upgrade to libp2p@0.45 ([#1400](https://github.com/waku-org/js-waku/issues/1400)) ([420e6c6](https://github.com/waku-org/js-waku/commit/420e6c698dd8f44d40d34e47d876da5d2e1ce85e))


### Dependencies

* The following workspace dependencies were updated
  * dependencies
    * @waku/utils bumped from 0.0.8 to 0.0.9
  * devDependencies
    * @waku/interfaces bumped from 0.0.15 to 0.0.16

## [0.0.12](https://github.com/waku-org/js-waku/compare/enr-v0.0.11...enr-v0.0.12) (2023-05-18)


### ⚠ BREAKING CHANGES

* @waku/relay ([#1316](https://github.com/waku-org/js-waku/issues/1316))

### Features

* @waku/relay ([#1316](https://github.com/waku-org/js-waku/issues/1316)) ([50c2c25](https://github.com/waku-org/js-waku/commit/50c2c2540f3c5ff78d93f3fea646da0eee246e17))


### Dependencies

* The following workspace dependencies were updated
  * dependencies
    * @waku/utils bumped from * to 0.0.6
  * devDependencies
    * @waku/interfaces bumped from 0.0.12 to 0.0.13

## [0.0.9](https://github.com/waku-org/js-waku/compare/enr-v0.0.8...enr-v0.0.9) (2023-03-28)


### Bug Fixes

* Ensure that websocket multiaddrs are returned from ENR ([#1275](https://github.com/waku-org/js-waku/issues/1275)) ([9494041](https://github.com/waku-org/js-waku/commit/94940411b0fd525044765b9068068ddf274eba2f)), closes [#1271](https://github.com/waku-org/js-waku/issues/1271)

## [0.0.6](https://github.com/waku-org/js-waku/compare/enr-v0.0.5...enr-v0.0.6) (2023-03-16)


### ⚠ BREAKING CHANGES

* add exports map to @waku/utils ([#1201](https://github.com/waku-org/js-waku/issues/1201))
* directly convert from ENR to `PeerInfo`, remove unneeded utility
* extract encoder code
* extract decoder code
* bump typescript
* bump all prod dependencies
* bump libp2p dependencies

### Bug Fixes

* Prettier and cspell ignore CHANGELOG ([#1235](https://github.com/waku-org/js-waku/issues/1235)) ([4d7b3e3](https://github.com/waku-org/js-waku/commit/4d7b3e39e6761afaf5d05a13cc4b3c23e15f9bd5))


### Miscellaneous Chores

* Add exports map to @waku/utils ([#1201](https://github.com/waku-org/js-waku/issues/1201)) ([a30b2bd](https://github.com/waku-org/js-waku/commit/a30b2bd747dedeef69b46cfafb88898ba35d8f67))
* Bump all prod dependencies ([88cc76d](https://github.com/waku-org/js-waku/commit/88cc76d2b811e1fa4460207f38704ecfe18fb260))
* Bump libp2p dependencies ([803ae7b](https://github.com/waku-org/js-waku/commit/803ae7bd8ed3de665026446c23cde90e7eba9d36))
* Bump typescript ([12d86e6](https://github.com/waku-org/js-waku/commit/12d86e6abcc68e27c39ca86b4f0dc2b68cdd6000))
* Directly convert from ENR to `PeerInfo`, remove unneeded utility ([6dbcde0](https://github.com/waku-org/js-waku/commit/6dbcde041ab8fa8c2df75cc25319a0eccf6b0454))
* Extract decoder code ([130c49b](https://github.com/waku-org/js-waku/commit/130c49b636807063364f309da0da2a24a68f2178))
* Extract encoder code ([22ffcf5](https://github.com/waku-org/js-waku/commit/22ffcf571aa3998267f0f3b59576abc38f3f4281))


### Dependencies

* The following workspace dependencies were updated
  * dependencies
    * @waku/utils bumped from * to 0.0.2
  * devDependencies
    * @waku/interfaces bumped from * to 0.0.8

## [Unreleased]

## [0.0.5] - 2023-01-25

### Fixed

- Moved `chai` to `devDependencies`.

## [0.0.4] - 2023-01-18

### Fixed

- Dependencies.

[unreleased]: https://github.com/waku-org/js-waku/compare/@waku/enr@0.0.5...HEAD
[0.0.5]: https://github.com/status-im/js-waku/compare/@waku/enr@0.0.4...@waku/enr@0.0.5
[0.0.4]: https://github.com/status-im/js-waku/compare/f7f28f03b01fa5bc89eaeb083b68981169b45c39...@waku/enr@0.0.4
